Index: issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp	(revision 27035)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp	(revision 27232)
@@ -10,5 +10,5 @@
 #include "../solutionsequences/solutionsequences.h"
 
-void solutionsequence_hydro_nonlinear(FemModel* femmodel){
+void solutionsequence_hydro_nonlinear(FemModel* femmodel, bool* pconv_fail){
 	/*solution : */
 	Vector<IssmDouble>* ug_sed=NULL;
@@ -16,14 +16,14 @@
 	Vector<IssmDouble>* uf_sed_sub_iter=NULL;
 	Vector<IssmDouble>* ug_sed_main_iter=NULL;
+	Vector<IssmDouble>* ug_sed_init=NULL;
 
 	Vector<IssmDouble>* ug_epl=NULL;
 	Vector<IssmDouble>* uf_epl=NULL;
 	Vector<IssmDouble>* uf_epl_sub_iter=NULL;
-	Vector<IssmDouble>* ug_epl_sub_iter=NULL;
 	Vector<IssmDouble>* ug_epl_main_iter=NULL;
+	Vector<IssmDouble>* ug_epl_init=NULL;
 
 	Vector<IssmDouble>* ys=NULL;
 	Vector<IssmDouble>* dug=NULL;
-	Vector<IssmDouble>* duf=NULL;
 
 	Matrix<IssmDouble>* Kff=NULL;
@@ -38,10 +38,12 @@
 	bool       sedconverged,eplconverged,hydroconverged;
 	bool       isefficientlayer;
+	bool       sliceadapt;
 	int        constraints_converged;
 	int        num_unstable_constraints;
 	int        sedcount,eplcount,hydrocount;
 	int        hydro_maxiter;
+	int        epl_fsize,epl_sub_fsize,epl_main_fsize;
 	IssmDouble sediment_kmax;
-	IssmDouble eps_hyd;
+	IssmDouble eps_res,eps_rel,eps_abs;
 	IssmDouble ndu_sed,nu_sed;
 	IssmDouble ndu_epl,nu_epl;
@@ -50,6 +52,9 @@
 	femmodel->SetCurrentConfiguration(HydrologyDCInefficientAnalysisEnum);
 	femmodel->parameters->FindParam(&isefficientlayer,HydrologydcIsefficientlayerEnum);
+	femmodel->parameters->FindParam(&sliceadapt,HydrologyStepAdaptEnum);
 	femmodel->parameters->FindParam(&hydro_maxiter,HydrologydcMaxIterEnum);
-	femmodel->parameters->FindParam(&eps_hyd,HydrologydcRelTolEnum);
+	femmodel->parameters->FindParam(&eps_res,StressbalanceRestolEnum);
+	femmodel->parameters->FindParam(&eps_rel,HydrologydcRelTolEnum);
+	femmodel->parameters->FindParam(&eps_abs,StressbalanceAbstolEnum);
 	hydrocount=1;
 	hydroconverged=false;
@@ -59,5 +64,11 @@
 	/*{{{*//*Retrieve inputs as the initial state for the non linear iteration*/
 	GetBasalSolutionFromInputsx(&ug_sed,femmodel);
+	/*Initialize the IDS element mask to exclude frozen nodes*/
+	inefanalysis->ElementizeIdsMask(femmodel);
+
 	Reducevectorgtofx(&uf_sed, ug_sed, femmodel->nodes,femmodel->parameters);
+	ug_sed_init=ug_sed->Duplicate();
+	ug_sed->Copy(ug_sed_init);
+
 	if(isefficientlayer) {
 		inefanalysis = new HydrologyDCInefficientAnalysis();
@@ -65,15 +76,12 @@
 		femmodel->SetCurrentConfiguration(HydrologyDCEfficientAnalysisEnum);
 		GetBasalSolutionFromInputsx(&ug_epl,femmodel);
-		/*Initialize the EPL element mask*/
 		inefanalysis->ElementizeEplMask(femmodel);
 		effanalysis->InitZigZagCounter(femmodel);
-		/*Initialize the IDS element mask*/
-		femmodel->SetCurrentConfiguration(HydrologyDCInefficientAnalysisEnum);
-		inefanalysis->ElementizeIdsMask(femmodel);
+		ug_epl_init=ug_epl->Duplicate();
+		ug_epl->Copy(ug_epl_init);
 	}
 	/*}}}*/
 	/*The real computation starts here, outermost loop is on the two layer system*/
 	for(;;){
-
 		sedcount=1;
 		eplcount=1;
@@ -105,4 +113,5 @@
 				/*{{{*//*Core of the computation*/
 				if(VerboseSolution()) _printf0_("Building Sediment Matrix...\n");
+
 				femmodel->profiler->Start(SEDMatrix);
 				SystemMatricesx(&Kff,&Kfs,&pf,&df,&sediment_kmax,femmodel);
@@ -114,7 +123,6 @@
 				femmodel->profiler->Start(SOLVER);
 				Solverx(&uf_sed,Kff,pf,uf_sed_sub_iter,df,femmodel->parameters);
+				delete df;
 				femmodel->profiler->Stop(SOLVER);
-
-				delete Kff; delete pf; delete df;
 				delete ug_sed;
 				femmodel->profiler->Start(SEDUpdate);
@@ -125,8 +133,18 @@
 				/*}}}*/
 				if (!sedconverged){
+					/*First check that all the penalizations are applied*/
 					if(VerboseConvergence()) _printf0_("   # Sediment unstable constraints = " << num_unstable_constraints << "\n");
-					if(num_unstable_constraints==0) sedconverged = true;
+					if(num_unstable_constraints==0) {
+						sedconverged = true;
+					}
+					else{//clean up
+						delete Kff;
+						delete pf;
+					}
 					if (sedcount>=hydro_maxiter){
+						delete ug_sed;delete uf_sed;delete inefanalysis; delete ug_sed_main_iter;
+						if(isefficientlayer)delete ug_epl;delete effanalysis; delete ug_epl_main_iter;
 						_error_("   maximum number of Sediment iterations (" << hydro_maxiter << ") exceeded");
+
 					}
 				}
@@ -135,23 +153,9 @@
 				if(sedconverged)break;
 			}
-
 			/*}}}*//*End of the sediment penalization loop*/
 			sedconverged=false;
-
 			/*Checking convergence on the value of the sediment head*/
-			duf=uf_sed_sub_iter->Duplicate();_assert_(duf);
-			uf_sed_sub_iter->Copy(duf);
-			duf->AYPX(uf_sed,-1.0);
-			ndu_sed=duf->Norm(NORM_TWO);
-			delete duf;
-			nu_sed=uf_sed_sub_iter->Norm(NORM_TWO);
-			if (xIsNan<IssmDouble>(ndu_sed) || xIsNan<IssmDouble>(nu_sed)) _error_("convergence criterion is NaN!");
-			if (ndu_sed==0.0 && nu_sed==0.0) nu_sed=1.0e-6; /*Hacking the case where the layer is empty*/
-			if(VerboseConvergence()) _printf0_(setw(50) << left << "   Inner Sediment Convergence criterion:" << ndu_sed/nu_sed*100 << "%, aiming lower than " << eps_hyd*10*100 << " %\n");
-			if((ndu_sed/nu_sed)<eps_hyd*10.){
-				if(VerboseConvergence()) _printf0_("   # Inner sediment convergence achieve \n");
-				sedconverged=true;
-			}
-			delete uf_sed_sub_iter;
+			convergence(&sedconverged,Kff,pf,uf_sed,uf_sed_sub_iter,eps_res,eps_rel,eps_abs);
+			delete Kff; delete pf;delete uf_sed_sub_iter;
 			if(sedconverged){
 				femmodel->parameters->SetParam(sediment_kmax,HydrologySedimentKmaxEnum);
@@ -176,6 +180,4 @@
 			for(;;){
 				eplconverged=false;
-				ug_epl_sub_iter=ug_epl->Duplicate();_assert_(ug_epl_sub_iter);
-				ug_epl->Copy(ug_epl_sub_iter);
 				/*{{{*//*Retrieve the EPL head slopes and compute EPL Thickness*/
 				if(VerboseSolution()) _printf0_("computing EPL Head slope...\n");
@@ -194,20 +196,19 @@
 				/*}}}*/
 				femmodel->profiler->Stop(EPLMasking);
+				Reducevectorgtofx(&uf_epl, ug_epl, femmodel->nodes,femmodel->parameters);
 				if(VerboseSolution()) _printf0_("Building EPL Matrix...\n");
+				uf_epl_sub_iter=uf_epl->Duplicate();_assert_(uf_epl_sub_iter);
+				uf_epl->Copy(uf_epl_sub_iter);
+				uf_epl->GetSize(&epl_sub_fsize);
 				femmodel->profiler->Start(EPLMatrices);
 				SystemMatricesx(&Kff,&Kfs,&pf,&df,NULL,femmodel);
 				CreateNodalConstraintsx(&ys,femmodel->nodes);
-				Reduceloadx(pf,Kfs,ys); delete Kfs;
-				delete uf_epl;
+				Reduceloadx(pf,Kfs,ys);
+				delete Kfs;delete uf_epl;
 				femmodel->profiler->Stop(EPLMatrices);
 				femmodel->profiler->Start(SOLVER);
 				Solverx(&uf_epl,Kff,pf,uf_epl_sub_iter,df,femmodel->parameters);
 				femmodel->profiler->Stop(SOLVER);
-
-				delete Kff; delete pf; delete df;
-				delete uf_epl_sub_iter;
-				uf_epl_sub_iter=uf_epl->Duplicate();_assert_(uf_epl_sub_iter);
-				uf_epl->Copy(uf_epl_sub_iter);
-				delete ug_epl;
+				delete df;delete ug_epl;
 				femmodel->profiler->Start(EPLUpdate);
 				Mergesolutionfromftogx(&ug_epl,uf_epl,ys,femmodel->nodes,femmodel->parameters); delete ys;
@@ -215,25 +216,33 @@
 				ConstraintsStatex(&constraints_converged,&num_unstable_constraints,femmodel);
 				femmodel->profiler->Stop(EPLUpdate);
-
-				dug=ug_epl_sub_iter->Duplicate();_assert_(dug);
-				ug_epl_sub_iter->Copy(dug);
-				dug->AYPX(ug_epl,-1.0);
-				ndu_epl=dug->Norm(NORM_TWO);
-				delete dug;
-				nu_epl=ug_epl_sub_iter->Norm(NORM_TWO);
-				if (xIsNan<IssmDouble>(ndu_epl) || xIsNan<IssmDouble>(nu_epl)) _error_("convergence criterion is NaN!");
-				if (ndu_epl==0.0 && nu_epl==0.0) nu_epl=1.0e-6; /*Hacking the case where the EPL is used but empty*/
-				if(VerboseConvergence()) _printf0_(setw(50) << left << "   Inner EPL Convergence criterion:" << ndu_epl/nu_epl*100 << "%, aiming lower than " << eps_hyd*10*100 << " %\n");
-				if((ndu_epl/nu_epl)<eps_hyd*10.) eplconverged=true;
-				if (eplcount>=hydro_maxiter){
+				uf_epl->GetSize(&epl_fsize);
+				if(epl_fsize-epl_sub_fsize==0){
+					convergence(&eplconverged,Kff,pf,uf_epl,uf_epl_sub_iter,eps_res,eps_rel,eps_abs);
+					delete Kff; delete pf;
+				}
+				else{
+					delete Kff; delete pf;
+				}
+
+				if (eplcount>=hydro_maxiter*9/10 && sliceadapt && !eplconverged) {
+					if(VerboseSolution()) _printf0_("epl did not converged after "<<eplconverged<<" iteration, we refine the steping\n");
+					*pconv_fail = true;
+					InputUpdateFromSolutionx(femmodel,ug_epl_init);
+					delete ug_epl_init;
+					femmodel->SetCurrentConfiguration(HydrologyDCInefficientAnalysisEnum);
+					InputUpdateFromSolutionx(femmodel,ug_sed_init);
+					delete ug_sed_init;
+					break;
+				}
+				else if (eplcount>=hydro_maxiter){
+					delete ug_sed;delete uf_sed;delete inefanalysis;delete ug_sed_main_iter;
+					delete ug_epl;delete uf_epl;delete effanalysis;delete ug_epl_main_iter;
 					_error_("   maximum number of EPL iterations (" << hydro_maxiter << ") exceeded");
+
 				}
 				eplcount++;
-
-				delete ug_epl_sub_iter;
+				delete uf_epl_sub_iter; delete uf_epl;
 				if(eplconverged){
 					if(VerboseSolution()) _printf0_("eplconverged...\n");
-					InputUpdateFromConstantx(femmodel,eplconverged,ConvergedEnum);
-					InputUpdateFromSolutionx(femmodel,ug_epl);
 					effanalysis->ResetCounter(femmodel);
 					break;
@@ -242,4 +251,7 @@
 		}
 		femmodel->profiler->Stop(EPLLOOP);
+		if(*pconv_fail){
+			break;
+		}
 		/*}}}*//*End of the global EPL loop*/
 		/*{{{*//*Now dealing with the convergence of the whole system*/
@@ -264,18 +276,32 @@
 			if (xIsNan<IssmDouble>(ndu_epl) || xIsNan<IssmDouble>(nu_epl)) _error_("EPL convergence criterion is NaN!");
 			if (ndu_epl==0.0 && nu_epl==0.0) nu_epl=1.0e-6; /*Hacking the case where the EPL is used but empty*/
-			if (!xIsNan<IssmDouble>(eps_hyd)){
-				if ((ndu_epl/nu_epl)<eps_hyd && (ndu_sed/nu_sed)<(eps_hyd)){
+			if (!xIsNan<IssmDouble>(eps_rel)){
+				if ((ndu_epl/nu_epl)<eps_rel && (ndu_sed/nu_sed)<(eps_rel)){
 					if (VerboseConvergence()) _printf0_(setw(50) << left << "   Converged after, " << hydrocount << " iterations \n");
 					hydroconverged=true;
 				}
 				else{
-					if(VerboseConvergence()) _printf0_(setw(50) << left << "   Sediment Convergence criterion:" << ndu_sed/nu_sed*100 << "%, aiming lower than " << eps_hyd*100 << " %\n");
-					if(VerboseConvergence()) _printf0_(setw(50) << left << "   EPL Convergence criterion:" << ndu_epl/nu_epl*100 << "%, aiming lower than " << eps_hyd*100 << " %\n");
+					if(VerboseConvergence()) _printf0_(setw(50) << left << "   for iteration:" << hydrocount << " \n");
+					if(VerboseConvergence()) _printf0_(setw(50) << left << "   Sediment Convergence criterion:" << ndu_sed/nu_sed*100 << "%, aiming lower than " << eps_rel*100 << " %\n");
+					if(VerboseConvergence()) _printf0_(setw(50) << left << "   EPL Convergence criterion:" << ndu_epl/nu_epl*100 << "%, aiming lower than " << eps_rel*100 << " %\n");
 					hydroconverged=false;
 				}
 			}
 			else _printf0_(setw(50) << left << "   Convergence criterion:" << ndu_sed/nu_sed*100 << " %\n");
+
+			if (hydrocount>=hydro_maxiter*9/10  && sliceadapt && !hydroconverged) {
+				if(VerboseSolution()) _printf0_("hydrology main loop  did not converged after "<<hydrocount<<" iteration, we refine the steping\n");
+				*pconv_fail = true;
+				InputUpdateFromSolutionx(femmodel,ug_epl_init);
+				delete ug_epl_init;
+				femmodel->SetCurrentConfiguration(HydrologyDCInefficientAnalysisEnum);
+				InputUpdateFromSolutionx(femmodel,ug_sed_init);
+				delete ug_sed_init;
+				break;
+			}
 			if (hydrocount>=hydro_maxiter){
 				_error_("   maximum number for hydrological global iterations (" << hydro_maxiter << ") exceeded");
+				delete ug_sed;delete uf_sed;delete effanalysis;
+				delete ug_epl;	delete uf_epl;	delete inefanalysis;
 			}
 		}
@@ -284,14 +310,14 @@
 	}
 	/*}}}*/
-	if(isefficientlayer)InputUpdateFromSolutionx(femmodel,ug_epl);
-	femmodel->SetCurrentConfiguration(HydrologyDCInefficientAnalysisEnum);
-	InputUpdateFromSolutionx(femmodel,ug_sed);
-	/*Free ressources: */
-	delete ug_epl;
-	delete ug_sed;
+	/*To deal with adaptative stepping we only save results if we are actually converged*/
+	if(hydroconverged){
+		if(isefficientlayer){
+			delete ug_epl_init;
+		}
+		delete ug_sed_init;
+	}
+	/*Free resources: */
+	delete ug_epl;delete ug_sed;
 	delete uf_sed;
-	delete uf_epl;
-	delete uf_epl_sub_iter;
-	delete inefanalysis;
-	delete effanalysis;
+	delete inefanalysis;	delete effanalysis;
 }
Index: issm/trunk/src/c/solutionsequences/solutionsequence_thermal_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_thermal_nonlinear.cpp	(revision 27035)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_thermal_nonlinear.cpp	(revision 27232)
@@ -131,5 +131,5 @@
 	}
 
-	/*Free ressources: */
+	/*Free resources: */
 	delete tg;
 	delete tf;
Index: issm/trunk/src/c/solutionsequences/solutionsequences.h
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequences.h	(revision 27035)
+++ issm/trunk/src/c/solutionsequences/solutionsequences.h	(revision 27232)
@@ -13,5 +13,5 @@
 
 void solutionsequence_thermal_nonlinear(FemModel* femmodel);
-void solutionsequence_hydro_nonlinear(FemModel* femmodel);
+void solutionsequence_hydro_nonlinear(FemModel* femmodel, bool* conv_fail);
 void solutionsequence_shakti_nonlinear(FemModel* femmodel);
 void solutionsequence_glads_nonlinear(FemModel* femmodel);
Index: issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiDenseMat.h	(revision 27232)
@@ -266,5 +266,5 @@
 			/*}}}*/
 
-			/*Free ressources:{{{*/
+			/*Free resources:{{{*/
 			xDelete<int>(RowRank);
 			xDelete<int>(row_indices_forcpu);
@@ -376,5 +376,5 @@
 			}
 
-			/*Free ressources: */
+			/*Free resources: */
 			xDelete<doubletype>(X_serial);
 		}
Index: issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiSparseMat.h	(revision 27232)
@@ -292,5 +292,5 @@
 			for(int i=0;i<this->m;i++) this->matrix[i]->SetValues(numvalues_perrow[i],cols_perrow[i],values_perrow[i],mods_perrow[i]);
 
-			/*Free ressources*/
+			/*Free resources:*/
 			xDelete<int>(numvalues_perrow);
 			xDelete<int>(RowRank);
@@ -394,5 +394,5 @@
 			}
 
-			/*Free ressources: */
+			/*Free resources: */
 			xDelete<doubletype>(X_serial);
 		}
Index: issm/trunk/src/c/toolkits/issm/IssmMpiVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmMpiVec.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/issm/IssmMpiVec.h	(revision 27232)
@@ -279,5 +279,5 @@
 			this->isassembled=true;
 
-			/*Free ressources:{{{*/
+			/*Free resources:{{{*/
 			xDelete<int>(RowRank);
 			xDelete<int>(row_indices_forcpu);
@@ -468,5 +468,5 @@
 			/*All gather:*/
 			ISSM_MPI_Allgatherv(this->vector, this->m, TypeToMPIType<doubletype>(), buffer, recvcounts, displs, TypeToMPIType<doubletype>(),comm);
-			/*free ressources: */
+			/*Free resources: */
 			xDelete<int>(recvcounts);
 			xDelete<int>(displs);
Index: issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp	(revision 27232)
@@ -48,5 +48,5 @@
 	else _error_("matrix type not supported yet!");
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<char>(mat_type);
 
@@ -78,5 +78,5 @@
 	else _error_("vector type not supported yet!");
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<char>(vec_type);
 
@@ -107,5 +107,5 @@
 	else _error_("solver type not supported yet!");
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<char>(solver_type);
 
Index: issm/trunk/src/c/toolkits/mpi/commops/DetermineLocalSize.cpp
===================================================================
--- issm/trunk/src/c/toolkits/mpi/commops/DetermineLocalSize.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/mpi/commops/DetermineLocalSize.cpp	(revision 27232)
@@ -50,5 +50,5 @@
 	local_size=num_local_rows[my_rank];
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<int>(num_local_rows);
 
Index: issm/trunk/src/c/toolkits/objects/Matrix.h
===================================================================
--- issm/trunk/src/c/toolkits/objects/Matrix.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/objects/Matrix.h	(revision 27232)
@@ -151,5 +151,5 @@
 			}
 
-			/*Free ressources: */
+			/*Free resources: */
 			xDelete<char>(toolkittype);
 		}
Index: issm/trunk/src/c/toolkits/objects/Vector.h
===================================================================
--- issm/trunk/src/c/toolkits/objects/Vector.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/objects/Vector.h	(revision 27232)
@@ -123,5 +123,5 @@
 			}
 
-			/*Free ressources: */
+			/*Free resources: */
 			xDelete<char>(toolkittype);
 		}
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 27232)
@@ -8,6 +8,4 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
-
-#include <petscversion.h>
 
 #include "./PetscSolver.h"
@@ -228,5 +226,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(pressure_indices);
 	xDelete<int>(velocity_indices);
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 27232)
@@ -10,6 +10,4 @@
 
 /*Petsc includes: */
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 27232)
@@ -10,6 +10,4 @@
 
 /*Petsc includes: */
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 27232)
@@ -10,6 +10,4 @@
 
 /*Petsc includes: */
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/KSPFree.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatFree.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
@@ -107,5 +104,5 @@
 	VecAssemblyEnd(outvector);; 
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(index);
 	xDelete<double>(values);	
Index: issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 27232)
@@ -10,7 +10,5 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscksp.h>
 
 #include "./petscpatches.h"
Index: issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp	(revision 27232)
@@ -10,7 +10,4 @@
 
 /*Petsc includes: */
-#include <petscversion.h>
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
 
Index: issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 27232)
@@ -93,5 +93,5 @@
 	*pgathered_vector=gathered_vector;
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<int>(idxn);
 	xDelete<double>(local_vector);
Index: issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 27232)
@@ -6,8 +6,5 @@
 #define _PETSC_PATCHES_H_
 
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
-#include <petscsys.h>
 
 #include "./SolverEnum.h"
Index: issm/trunk/src/c/toolkits/petsc/petscincludes.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/petscincludes.h	(revision 27035)
+++ issm/trunk/src/c/toolkits/petsc/petscincludes.h	(revision 27232)
@@ -9,8 +9,5 @@
 
 /*Petsc includes: */
-#include <petscmat.h>
-#include <petscvec.h>
 #include <petscksp.h>
-#include <petscsys.h>
 
 /*our own patches: */
Index: issm/trunk/src/m/classes/SMBgemb.m
===================================================================
--- issm/trunk/src/m/classes/SMBgemb.m	(revision 27035)
+++ issm/trunk/src/m/classes/SMBgemb.m	(revision 27232)
@@ -73,5 +73,5 @@
 		% 2: default value of 1, in areas with grain radius below teThresh and areas of dry snow (not bare ice or wet) at the surface
 
-		swIdx  = NaN; % apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002))
+		swIdx  = NaN; %apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 0, if swIdx=1 and aIdx=2, function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002))
 
 		denIdx = NaN; %densification model to use (default is 2):
@@ -236,5 +236,5 @@
 			end
 
-			fielddisplay(self,'swIdx','apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)]');
+			fielddisplay(self,'swIdx','apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 0, if swIdx=1 and aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)]');
 			fielddisplay(self,'denIdx',{'densification model to use (default is 2):',...
 				'1 = emperical model of Herron and Langway (1980)',...
@@ -343,5 +343,5 @@
 			self.aIdx = 1;
 			self.eIdx = 1;
-			self.swIdx = 1;
+			self.swIdx = 0;
 			self.denIdx = 2;
 			self.dsnowIdx = 1;
Index: issm/trunk/src/m/classes/SMBgemb.py
===================================================================
--- issm/trunk/src/m/classes/SMBgemb.py	(revision 27035)
+++ issm/trunk/src/m/classes/SMBgemb.py	(revision 27232)
@@ -80,5 +80,5 @@
         # 2: default value of 1, in areas with grain radius below teThresh and areas of dry snow (not bare ice or wet) at the surface
 
-        self.swIdx                  = np.nan    # apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002))
+        self.swIdx                  = np.nan    # apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 0, if swIdx=1 and aIdx=2, function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)) 
 
         self.denIdx                 = np.nan    # densification model to use (default is 2):
@@ -238,5 +238,5 @@
             s += '{}\n'.format(fielddisplay(self, 'K', 'time scale temperature coef. (7) [d]'))
 
-        s += '{}\n'.format(fielddisplay(self, 'swIdx', 'apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)]'))
+        s += '{}\n'.format(fielddisplay(self, 'swIdx', 'apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 0, if swIdx=1 and aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)]'))
         s += '{}\n'.format(fielddisplay(self, 'denIdx', ['densification model to use (default is 2):',
             '1 = emperical model of Herron and Langway (1980)',
@@ -330,5 +330,5 @@
         self.aIdx = 1
         self.eIdx = 1
-        self.swIdx = 1
+        self.swIdx = 0 
         self.denIdx = 2
         self.dsnowIdx = 1
Index: issm/trunk/src/m/classes/age.m
===================================================================
--- issm/trunk/src/m/classes/age.m	(revision 27232)
+++ issm/trunk/src/m/classes/age.m	(revision 27232)
@@ -0,0 +1,115 @@
+%AGE class definition
+%
+%   Usage:
+%      age=age();
+
+classdef age
+	properties (SetAccess=public)
+		 spcage                 = NaN;
+		 stabilization          = 0;
+		 requested_outputs      = {};
+	end
+	methods (Static)
+		function self = loadobj(self) % {{{
+			% This function is directly called by matlab when a model object is
+			% loaded. If the input is a struct it is an old version of this class and
+			% old fields must be recovered (make sure they are in the deprecated
+			% model properties)
+
+			if verLessThan('matlab','7.9'),
+				disp('Warning: your matlab version is old and there is a risk that load does not work correctly');
+				disp('         if the model is not loaded correctly, rename temporarily loadobj so that matlab does not use it');
+
+				% This is a Matlab bug: all the fields of md have their default value
+				% Example of error message:
+				% Warning: Error loading an object of class 'model':
+				% Undefined function or method 'exist' for input arguments of type 'cell'
+				%
+				% This has been fixed in MATLAB 7.9 (R2009b) and later versions
+			end
+
+			if isstruct(self)
+				disp('Recovering age from older version');
+				self = structtoobj(age(),self);
+			end
+		end% }}}
+	end
+	methods
+		function self = age(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				case 1
+					inputstruct=varargin{1};
+					list1 = properties('age');
+					list2 = fieldnames(inputstruct);
+					for i=1:length(list1)
+						fieldname = list1{i};
+						if ismember(fieldname,list2),
+							self.(fieldname) = inputstruct.(fieldname);
+						end
+					end
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+			self.spcage=project3d(md,'vector',self.spcage,'type','node');
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+
+			list = {'Age'};
+
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+
+			%Type of stabilization to use 0:nothing 1:artificial_diffusivity
+			self.stabilization=2;
+
+			%default output
+			self.requested_outputs={'default'};
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			%Early return
+			if ~ismember('AgeAnalysis',analyses) |  (strcmp(solution,'TransientSolution') & md.transient.isage==0), return; end
+			if dimension(md.mesh)~=3
+				md = checkmessage(md,['age model only supported in 3D']);
+			end
+
+			md = checkfield(md,'fieldname','age.spcage','Inf',1,'timeseries',1);
+			md = checkfield(md,'fieldname','age.stabilization','values',[0 1 2 4 5]);
+			md = checkfield(md,'fieldname','age.requested_outputs','stringrow',1);
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   Masstransport solution parameters:'));
+			fielddisplay(self,'spcage','Age constraint (NaN means no constraint) [yr]');
+			fielddisplay(self,'stabilization','0: no stabilization, 1: artificial diffusion, 2: streamline upwinding, 4: flux corrected transport, 5: streamline upwind Petrov-Galerkin (SUPG)');
+			fielddisplay(self,'requested_outputs','additional outputs requested');
+
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			yts=md.constants.yts;
+
+			WriteData(fid,prefix,'object',self,'fieldname','spcage','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','stabilization','format','Integer');
+
+			%process requested outputs
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];                         %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.age.requested_outputs','format','StringArray');
+		end % }}}
+		function savemodeljs(self,fid,modelname) % {{{
+
+			writejs1Darray(fid,[modelname '.age.spcage'],self.spcage);
+			writejsdouble(fid,[modelname '.age.stabilization'],self.stabilization);
+			writejscellstring(fid,[modelname '.age.requested_outputs'],self.requested_outputs);
+
+		end % }}}
+	end
+end
